using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {      
	CategoryBuilder.Create(" GBRS Group", "", ModAPI.LoadSprite("category icon.png"));       






ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "[GBRS] Mechanix Vision Type-N", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4z",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/tnicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/tn.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/tn.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[GBRS] Mechanix Glove", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4z",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/gloveicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/glove1.png", 15f);
 
                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/glove1.png", 15);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 5;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/glove2.png", 15);
                        armProp[0].armorPiece = "LowerArm";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 5;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Hydra Mount Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "9",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("weapon/s1.png", 15f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/s1.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Hydra Mount Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "9",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("weapon/s2.png", 15f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/s2.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Hydra Mount Variant 3",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "9",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("weapon/s3.png", 15f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/s3.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Hydra Mount Variant 4",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "9",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("weapon/s5.png", 15f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/s5.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "2.91 FTC Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "9",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("weapon/s4.png", 15f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/s4.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "2.91 FTC Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "9",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("weapon/s6.png", 15f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/s6.png", 15f);
                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] HK416 Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hk416icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/hkslide.png", 15f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/hk416.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HKBack = new GameObject("HK416");
                        HKBack.transform.SetParent(Instance.transform);
                        HKBack.transform.localPosition = new Vector2(0f, 0f);
                        HKBack.transform.localScale = new Vector3(1f, 1f);
                        HKBack.transform.rotation = Instance.transform.rotation;
                        var HKBackSprite = HKBack.AddComponent<SpriteRenderer>();
                        HKBackSprite.sprite = ModAPI.LoadSprite("weapon/hkback.png", 15f);
                        HKBackSprite.sortingLayerName = "Bottom"; 


                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/hk416.png", 15f);
                        HKSprite.sortingLayerName = "Foreground"; 


                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.210f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.14f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/hksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil *= 5f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] HK416 Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hk4162icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/hkslide.png", 15f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/hk4162.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var HKBack = new GameObject("HK416");
                        HKBack.transform.SetParent(Instance.transform);
                        HKBack.transform.localPosition = new Vector2(0f, 0f);
                        HKBack.transform.localScale = new Vector3(1f, 1f);
                        HKBack.transform.rotation = Instance.transform.rotation;
                        var HKBackSprite = HKBack.AddComponent<SpriteRenderer>();
                        HKBackSprite.sprite = ModAPI.LoadSprite("weapon/hkback.png", 15f);
                        HKBackSprite.sortingLayerName = "Bottom"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/hk4162.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.210f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.14f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/hksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil *= 5f;
                        customCartridge.ImpactForce *= 6f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] MP7",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp7icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var MP7Slide = Instance.transform.Find("Slide");
                       MP7Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/mp7slide.png", 15f);
                       MP7Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/mp7.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var MP7Back = new GameObject("MP7");
                        MP7Back.transform.SetParent(Instance.transform);
                        MP7Back.transform.localPosition = new Vector2(0f, 0f);
                        MP7Back.transform.localScale = new Vector3(1f, 1f);
                        MP7Back.transform.rotation = Instance.transform.rotation;
                        var MP7BackSprite = MP7Back.AddComponent<SpriteRenderer>();
                        MP7BackSprite.sprite = ModAPI.LoadSprite("weapon/mp7back.png", 15f);
                        MP7BackSprite.sortingLayerName = "Bottom"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/mp7.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.519f,0.110f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.13f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/mp7sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage = 4f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 4f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] SP5K-PDW",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/sp5kicon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var SP5KSlide = Instance.transform.Find("Slide");
                       SP5KSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/sp5kslide.png", 15f);
                       SP5KSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/sp5k.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var SP5KBack = new GameObject("MP7");
                        SP5KBack.transform.SetParent(Instance.transform);
                        SP5KBack.transform.localPosition = new Vector2(0f, 0f);
                        SP5KBack.transform.localScale = new Vector3(1f, 1f);
                        SP5KBack.transform.rotation = Instance.transform.rotation;
                        var SP5KBackSprite = SP5KBack.AddComponent<SpriteRenderer>();
                        SP5KBackSprite.sprite = ModAPI.LoadSprite("weapon/sp5kback.png", 15f);
                        SP5KBackSprite.sortingLayerName = "Bottom"; 

                        var HK = new GameObject("SP5K");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/sp5k.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.539f,0.110f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/sp5ksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage = 4f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 4f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] B&T TP9-N Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/tp9icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var TP9Slide = Instance.transform.Find("Slide");
                       TP9Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/tp9slide.png", 15f);
                       TP9Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/tp9.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var TP9Back = new GameObject("MP7");
                        TP9Back.transform.SetParent(Instance.transform);
                        TP9Back.transform.localPosition = new Vector2(0f, 0f);
                        TP9Back.transform.localScale = new Vector3(1f, 1f);
                        TP9Back.transform.rotation = Instance.transform.rotation;
                        var TP9BackSprite = TP9Back.AddComponent<SpriteRenderer>();
                        TP9BackSprite.sprite = ModAPI.LoadSprite("weapon/tp9back.png", 15f);
                        TP9BackSprite.sortingLayerName = "Bottom"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/tp9.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.459f,0.110f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/tp9sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage = 4f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 4f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] B&T TP9-N Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/tp92icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var TP9Slide = Instance.transform.Find("Slide");
                       TP9Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/tp9slide.png", 15f);
                       TP9Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/tp92.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var TP9Back = new GameObject("MP7");
                        TP9Back.transform.SetParent(Instance.transform);
                        TP9Back.transform.localPosition = new Vector2(0f, 0f);
                        TP9Back.transform.localScale = new Vector3(1f, 1f);
                        TP9Back.transform.rotation = Instance.transform.rotation;
                        var TP9BackSprite = TP9Back.AddComponent<SpriteRenderer>();
                        TP9BackSprite.sprite = ModAPI.LoadSprite("weapon/tp9back.png", 15f);
                        TP9BackSprite.sortingLayerName = "Bottom"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/tp92.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.459f,0.110f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/tp9sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage = 4f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 4f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );


 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] BCM 11.5 Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bcmicon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var BCMSlide = Instance.transform.Find("Slide");
                       BCMSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/bcmslide.png", 15f);
                       BCMSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/bcm.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var BCMBack = new GameObject("BCM");
                        BCMBack.transform.SetParent(Instance.transform);
                        BCMBack.transform.localPosition = new Vector2(0f, 0f);
                        BCMBack.transform.localScale = new Vector3(1f, 1f);
                        BCMBack.transform.rotation = Instance.transform.rotation;
                        var BCMBackSprite = BCMBack.AddComponent<SpriteRenderer>();
                        BCMBackSprite.sprite = ModAPI.LoadSprite("weapon/bcmback.png", 15f);
                        BCMBackSprite.sortingLayerName = "Bottom"; 

                        var LaserBack = new GameObject("Laser");
                        LaserBack.transform.SetParent(Instance.transform);
                        LaserBack.transform.localPosition = new Vector2(0f, 0f);
                        LaserBack.transform.localScale = new Vector3(1f, 1f);
                        LaserBack.transform.rotation = Instance.transform.rotation;
                        var LaserBackSprite = LaserBack.AddComponent<SpriteRenderer>();
                        LaserBackSprite.sprite = ModAPI.LoadSprite("weapon/bcmlaser.png", 15f);
                        LaserBackSprite.sortingLayerName = "Top"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/bcm.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.230f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
			}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/bcmsound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] BCM 11.5 Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bcm2icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var BCMSlide = Instance.transform.Find("Slide");
                       BCMSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/bcmslide.png", 15f);
                       BCMSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/bcm2.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var BCMBack = new GameObject("BCM");
                        BCMBack.transform.SetParent(Instance.transform);
                        BCMBack.transform.localPosition = new Vector2(0f, 0f);
                        BCMBack.transform.localScale = new Vector3(1f, 1f);
                        BCMBack.transform.rotation = Instance.transform.rotation;
                        var BCMBackSprite = BCMBack.AddComponent<SpriteRenderer>();
                        BCMBackSprite.sprite = ModAPI.LoadSprite("weapon/bcmback.png", 15f);
                        BCMBackSprite.sortingLayerName = "Bottom"; 

                        var LaserBack = new GameObject("Laser");
                        LaserBack.transform.SetParent(Instance.transform);
                        LaserBack.transform.localPosition = new Vector2(0f, 0f);
                        LaserBack.transform.localScale = new Vector3(1f, 1f);
                        LaserBack.transform.rotation = Instance.transform.rotation;
                        var LaserBackSprite = LaserBack.AddComponent<SpriteRenderer>();
                        LaserBackSprite.sprite = ModAPI.LoadSprite("weapon/bcmlaser.png", 15f);
                        LaserBackSprite.sortingLayerName = "Top"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/bcm2.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.230f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
			}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/bcmsound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] BCM 11.5 Variant 3",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bcm3icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var BCMSlide = Instance.transform.Find("Slide");
                       BCMSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/bcmslide.png", 15f);
                       BCMSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/bcm3.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var BCMBack = new GameObject("BCM");
                        BCMBack.transform.SetParent(Instance.transform);
                        BCMBack.transform.localPosition = new Vector2(0f, 0f);
                        BCMBack.transform.localScale = new Vector3(1f, 1f);
                        BCMBack.transform.rotation = Instance.transform.rotation;
                        var BCMBackSprite = BCMBack.AddComponent<SpriteRenderer>();
                        BCMBackSprite.sprite = ModAPI.LoadSprite("weapon/bcmback.png", 15f);
                        BCMBackSprite.sortingLayerName = "Bottom"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/bcm3.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.230f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
			}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/bcmsound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[GBRS] BCM 11.5 Variant 4",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bcm4icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var BCMSlide = Instance.transform.Find("Slide");
                       BCMSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/bcmslide.png", 15f);
                       BCMSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/bcm4.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var BCMBack = new GameObject("BCM");
                        BCMBack.transform.SetParent(Instance.transform);
                        BCMBack.transform.localPosition = new Vector2(0f, 0f);
                        BCMBack.transform.localScale = new Vector3(1f, 1f);
                        BCMBack.transform.rotation = Instance.transform.rotation;
                        var BCMBackSprite = BCMBack.AddComponent<SpriteRenderer>();
                        BCMBackSprite.sprite = ModAPI.LoadSprite("weapon/bcmback.png", 15f);
                        BCMBackSprite.sortingLayerName = "Bottom"; 

                        var HK = new GameObject("HK");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/bcm4.png", 15f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.230f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
			}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/bcmsound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage = 5f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Vest Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest1.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest1v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Vest Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3b",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Vest Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3c",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest6v2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest6.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest6v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Vest Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest3v2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest3.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest3v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Vest Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest4v2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest4.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest4v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Vest Variant 6", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3f",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest5v2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest5.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest5v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Waist Bag Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3g",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bag1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/bag1.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f); 
                        prop.armorPiece = "MiddleBody";                 
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/bag1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Waist Bag Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3g",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bag2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/bag2.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);  
                        prop.armorPiece = "MiddleBody";                 
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/bag2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Waist Bag Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3g",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bag3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/bag3.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);
                        prop.armorPiece = "MiddleBody";                   
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/bag3.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Belt Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3g",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/belticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/belt.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/belt.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Belt Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3h",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beltv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/beltv2.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/beltv2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
	);

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Belt Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3i",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beltv5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/beltv5.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/beltv5.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Belt Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3j",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beltv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/beltv3.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/beltv3.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Belt Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3k",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beltv4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/beltv4.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/beltv4.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Belt Variant 6", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3l",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beltv6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/beltv6.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/beltv6.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Helmet Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Helmet Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2b",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f); 
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;

                        ModAPI.CreateLight(Instance.transform, Color.cyan, 0.3f, 0.5f);

                        var childObject = new GameObject("gpnvg18glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(-0.031f, 0.003f);
                        childObject.transform.localScale = new Vector3(0.07f, 0.07f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Helmet/nightvisionglow.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(4.2f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Helmet Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2c",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Helmet Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f); 
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;

                        ModAPI.CreateLight(Instance.transform, Color.cyan, 0.3f, 0.5f);

                        var childObject = new GameObject("gpnvg18glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(-0.031f, 0.003f);
                        childObject.transform.localScale = new Vector3(0.07f, 0.07f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Helmet/nightvisionglow.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(4.2f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Helmet Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv5.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv5.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Helmet Variant 6", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv6.png", 17f); 
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;

                        ModAPI.CreateLight(Instance.transform, Color.cyan, 0.3f, 0.5f);

                        var childObject = new GameObject("gpnvg18glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(-0.031f, 0.003f);
                        childObject.transform.localScale = new Vector3(0.07f, 0.07f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Helmet/nightvisionglow.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv6.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(4.2f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Comtac Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/comtacicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/comtac.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/comtac.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Comtac Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/comtac2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/comtac2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/comtac2.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Comtac Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/comtac3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/comtac3.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/comtac3.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Comtac Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/comtac4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/comtac4.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/comtac4.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Comtac Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/comtac5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/comtac5.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/comtac5.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Comtac Variant 6", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/comtac6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/comtac6.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/comtac6.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Cap Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/capicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/cap.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/cap.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Cap Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2f",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cap2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/capv2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/capv2.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Cap Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2g",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cap3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/capv3.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/capv3.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Cap Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2h",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cap4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/capv4.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/capv4.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Cap Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2i",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cap5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/capv5.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/capv5.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Cap Variant 6", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2i",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cap6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/capv6.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/capv6.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Cap Variant 7", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2i",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/cap7icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/capv7.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder--;

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/capv7.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Beanie Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2j",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beanieicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/beanie.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/beanie.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Beanie Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2k",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beanie2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/beaniev2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/beaniev2.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Beanie Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2k",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beanie4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/beaniev4.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/beaniev4.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Beanie Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2k",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beanie3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/beaniev3.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/beaniev3.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Beanie Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2k",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/beanie5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/beaniev5.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/beaniev5.png", 17f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Patch [Global Battlefield Research Solutions]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch1.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch1.png", 20f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Patch [Grip Matters]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4b",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch2.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch2.png", 20f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Patch [GBRS Group Est.2019]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4c",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch3.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch3.png", 20f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Patch [Stagnant]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch4.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch4.png", 20f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Patch [GBRS Group]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4e",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch5.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch5.png", 20f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Patch [Stance Matters]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4f",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch6.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch6.png", 20f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            ); 

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[GBRS] Patch [GBRS Group x Tribe Sk8z]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4g",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/p7icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Patch/patch7.png", 20f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Patch/patch7.png", 20f);
                        prop.armorPoints = 20;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[GBRS] Variant 1",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1a",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1.png"),
                        };
                    }
                }
            );    

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[GBRS] Variant 2",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1b",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 2.png"),
                        };
                    }
                }
            );    

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[GBRS] Variant 3",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1c",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v3icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 3.png"),
                        };
                    }
                }
            );    

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[GBRS] Variant 4",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v4icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 4.png"),
                            ModAPI.LoadTexture("Outfit/Variant 4v2.png"),
                            ModAPI.LoadTexture("Outfit/Variant 4v3.png"),
                            ModAPI.LoadTexture("Outfit/Variant 6.png"),
                        };
                    }
                }
            );     

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[GBRS] Variant 5",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v5icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 5.png"),
                            ModAPI.LoadTexture("Outfit/Variant 5v2.png"),
                            ModAPI.LoadTexture("Outfit/Variant 5v3.png"),
                            ModAPI.LoadTexture("Outfit/Variant 5v4.png"),
                            ModAPI.LoadTexture("Outfit/Variant 5v5.png"),
                        };
                    }
                }
            );  

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[GBRS] Variant 6",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1d",
                    CategoryOverride = ModAPI.FindCategory(" GBRS Group"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v7icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 7.png"),
                            ModAPI.LoadTexture("Outfit/Variant 7v2.png"),
                            ModAPI.LoadTexture("Outfit/Variant 7v3.png"),
                        };
                    }
                }
            ); 








        }












public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
